import 'dart:async';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'chat_config_template.dart';

// final msgsProvider=StateNotifierProvider<msgsController,List<msg>?>((ref){
//   final cnl=ref.watch(selectedChannelPvd).state;
//   final offsetMsg=ref.read(msgOffsetPvd)[0];
//   if(offsetMsg==null) return msgsController(cnl,ref.read,[]);
//   else return msgsController(cnl,ref.read,[offsetMsg]);
// });

class msgsController<C,M> extends StateNotifier<List<M>?>{
  final Reader read;
  final C? cnl;
  final tempConfig_Msg<C,M> config;
  bool loadByLmt=true;
  // late List<M> cache;
  // late bool streamInCache;

  @protected
  StreamSubscription<List<M>>? msgSub;

  Future<Iterable<M>>loadb4(DateTime t,{int lmt=10})async=>await config.firestore
      .collection(config.getcPath(cnl!))
      .orderBy("time",descending: true)
      .limit(lmt)
      .startAfter([t.toUtc().toIso8601String()])
      .get()
      .then((v) => v.docs.map((e) => config.msgFromDoc(e, cnl!)));
  Future<Iterable<M>>loadaf(DateTime t,{int lmt=10})async=>await config.firestore
      .collection(config.getcPath(cnl!))
      .orderBy("time",descending: true)
      .endBefore([t.toUtc().toIso8601String()])
      .limitToLast(lmt)
      .get()
      .then((v) => v.docs.map((e) => config.msgFromDoc(e, cnl!)));

  msgsController(this.cnl,this.read,List<M> cache,
      {required this.config}) : super(null) {
    // streamInCache=false;
    msgSub?.cancel();
    if(cnl!=null){
      if(cache.isEmpty)initStream();
      else loadOffset(cache);//.then((v)=>initStream());
    }
  }

  void initStream({int defaultOffset=12}){
    assert(cnl!=null);
    msgSub?.cancel();
    var qr=config.firestore.collection(config.getcPath(cnl!))
        .orderBy("time",descending: true);

    loadByLmt=state==null||state!.length<defaultOffset;
    if(!loadByLmt){
      qr=qr.endAt([config.getTime(state!.last).toUtc().toIso8601String()]);}
    else{
      qr=qr.limit(defaultOffset);}
    msgSub=qr
        // .limit(cache.isEmpty?7:cache.length)
        .snapshots()
        .map((e) => e.docs.map((e) => config.msgFromDoc(e,cnl!)).toList())
        .listen((event) {
          if(mounted){
            state=List.of(event);
            if(loadByLmt&&event.isNotEmpty)initStream(defaultOffset: state!.length);
          }});
  }

  @override
  void dispose() {
    endStream();
    // TODO: implement dispose
    super.dispose();
  }

  void endStream(){
    msgSub?.pause();
    msgSub?.cancel();
  }

  Future<void> loadB4() async{
    if(msgSub!=null)initStream(defaultOffset: (state?.length??0)+10);
    if(read(config.loadingPvd)||state==null||state!.isEmpty)return;
    read(config.loadingPvd.state).state=true;
    final pre=await loadb4(config.getTime(state!.last));
    state=List.of(state!..addAll(pre));
    read(config.loadingPvd.state).state=false;
  }

  Future<void> loadAf() async{
    if(msgSub!=null)return;
    if(read(config.loadingPvd)||state==null||state!.isEmpty)return;
    read(config.loadingPvd.state).state=true;
    final post=await loadaf(config.getTime(state!.first));
    state=List.of(state!..insertAll(0,post));
    if(post.length<10)initStream();
    read(config.loadingPvd.state).state=false;
  }

  Future<void> loadOffset(List<M>cache)async{
    ///prevent setState while building message view
    ///todo: consider pause msgSub to stop stream, since could be
    ///      at same channel different searched msg,
    ///      but currently just rebuild whole provider
    if(read(config.loadingPvd))return;
    Future.microtask(() => read(config.loadingPvd.state).state=true);
    final pre=loadb4(config.getTime(cache.last))
        .then((v){
          cache.addAll(v);
        });
    final post=loadaf(config.getTime(cache.first),lmt: 2)
        .then((v){
          cache.insertAll(0,v);
          return v.length;
        });
    final r=await Future.wait([pre,post]);
    state=List.of(cache);
    if(r[1]!<2)initStream();
    read(config.loadingPvd.state).state=false;
  }
}