
import 'package:decimal/decimal.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';

import 'date.dart';

/// Currency formatter for USD.
NumberFormat usdWithSignFormat({int decimalDigits = 2}) {
  return NumberFormat.currency(
    name: '\$',
    decimalDigits: decimalDigits,
  );
}

String formate_amount(double? a) {
  return NumberFormat.currency(decimalDigits: 2, name: '\$').format(a);
}

/// Percent formatter with two decimal points.
NumberFormat percentFormat(BuildContext context, {int decimalDigits = 2}) {
  return NumberFormat.decimalPercentPattern(
    decimalDigits: decimalDigits,
  );
}

String formateDollar(double m,{bool addSign=true}){
  String mStr=m.toStringAsFixed(2);
  String rs=mStr.substring(mStr.length-3);
  mStr=mStr.substring(0,mStr.length-3);
  while(mStr.length>3){
    rs=","+mStr.substring(mStr.length-3)+rs;
    mStr=mStr.substring(0,mStr.length-3);
  }
  rs=addSign?("\$ "+mStr+rs):(mStr+rs);
  return rs;
}

String? formateDollarStr(String m,{bool addSign=true}){
  if(m.startsWith("\$"))m=m.substring(1);
  m=m.replaceAll(",", "");
  final s=double.tryParse(m);
  if(s==null)return null;
  return formateDollar(s,addSign:addSign);
}


//only allow decimal input, e.g. "12", "12.3". not allowed: ".12", "3.1.1"
class amountFormatter extends TextInputFormatter {
  @override
  TextEditingValue formatEditUpdate(TextEditingValue oldValue, TextEditingValue newValue) {
    String text = oldValue.text ;
    int offset = oldValue.selection.end;
    if(newValue.text.isEmpty||Decimal.tryParse(newValue.text)!=null) {
      text = newValue.text; offset = newValue.selection.end;
    }
    return TextEditingValue(
      text: text,
      selection: TextSelection.collapsed(offset: offset),
    );
  }
}
