import 'package:flutter/material.dart';
import 'package:flutter_form_builder/flutter_form_builder.dart';
import 'package:flutter_hooks/flutter_hooks.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

class SubForm_Field extends HookConsumerWidget {
  final String name;
  final Widget Function(BuildContext context,int i,Function()onpop) subformBuilder;
  final Widget Function(BuildContext context,Function()onadd) adderBuilder;
  final Widget? separator;
  final Function(int i,Map<String,dynamic>?)? onchanged;
  const SubForm_Field({Key? key,this.name="0",this.separator,this.onchanged,
    required this.subformBuilder,required this.adderBuilder}) : super(key: key);

  @override
  Widget build(BuildContext context,WidgetRef ref) {
    final fks=useRef<List<GlobalKey<FormBuilderState>>>([]);
    return FormBuilderField<List<Map<String,dynamic>>>(builder: (fs){
      useEffect((){
        fks.value=List.generate(fs.value?.length??0,
              (i) => GlobalKey<FormBuilderState>());
        },[name]);
      return Column(mainAxisSize:MainAxisSize.min,children: [
        ...List.generate(fs.value?.length??0, (i) => FormBuilder(key:fks.value[i],
            initialValue:fs.value?[i]??{},
            autovalidateMode: AutovalidateMode.onUserInteraction,autoFocusOnValidationFailure: true,
            onChanged: (){
              fs.didChange(List.of(fs.value!..[i]=fks.value[i].currentState!.value));
              if(onchanged!=null)onchanged!(i,fs.value?[i]);
            },
            child: subformBuilder(context,i,(){
              fs.didChange(List.of(fs.value!..removeAt(i)));
              fks.value=List.of(fks.value..removeAt(i));
            }))).expand((e) => [e,if(separator!=null)separator!]),
        adderBuilder(context,(){
          fs.didChange(List.of(fs.value!..add({})));
          fks.value=List.of(fks.value..add(GlobalKey<FormBuilderState>()));
        })
      ],);
    }, name: name,
      validator: (v){
      final valid=fks.value.every((k)=>k.currentState!.validate());
      if(!valid)return "";
      },
      onSaved: (v)=>fks.value.forEach((k)=>k.currentState!.save()),);
  }
}


