import 'package:flutter/material.dart';

class hightlightedBut extends StatelessWidget {
  final bool highlight;
  final Function(bool) onpress;
  final IconData icondata;
  final Color? highlightBackground;
  final Color? unhighlightBackground;
  final Color? highlightIcon;
  final Color? unhighlightIcon;
  final String? tooltip;
  final Decoration? tooltipDec;

  const hightlightedBut({Key? key,required this.icondata,
    required this.highlight,required this.onpress,
    this.highlightBackground, this.unhighlightBackground,
    this.highlightIcon=Colors.white, this.unhighlightIcon,
    this.tooltip, this.tooltipDec}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final icon=IconButton(onPressed: onpress(highlight),
        icon: Icon(icondata, color: highlight?Colors.white:unhighlightIcon ));

    return Container(decoration: BoxDecoration(borderRadius: BorderRadius.circular(3),
        color: highlight?(highlightBackground??Theme.of(context).colorScheme.primary):unhighlightBackground),
        child:tooltip==null?icon:Tooltip(message:tooltip!, decoration: tooltipDec,child: icon));
  }
}
